Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/interface/c/icdata.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/interface/c/icdata.cpp	(revision 2115)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/interface/c/icdata.cpp	(revision 2121)
@@ -864,15 +1049,22 @@
       std::string fieldid_str;
       if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS recv field").resume();
-
-      CContext* context = CContext::getCurrent();
-      if (!context->hasServer && !context->client->isAttachedModeEnabled())
-        context->eventLoop();
-//ym        context->checkBuffersAndListen();
-
-      CArray<double, 3>data(data_k8, shape(data_Xsize, data_Ysize, data_Zsize), neverDeleteData);
-      CField::get(fieldid_str)->getData(data);
+      cxios_read_data_k83_hdl(CField::get(fieldid_str), data_k8, data_Xsize, data_Ysize, data_Zsize) ;
+   }
+   CATCH_DUMP_STACK
+
+   void cxios_read_data_k84_hdl(CField* field, double* data_k8,
+                            int data_0size, int data_1size, int data_2size,
+                            int data_3size)
+   TRY
+   {
+      CTimer::get("XIOS").resume();
+      CTimer::get("XIOS recv field").resume();
+
+      CContext* context = CContext::getCurrent();
+      if (!context->hasServer && !context->client->isAttachedModeEnabled())
+        context->eventLoop();
+
+      CArray<double, 4>data(data_k8, shape(data_0size, data_1size, data_2size, data_3size), neverDeleteData);
+      field->getData(data);
 
       CTimer::get("XIOS recv field").suspend();
@@ -888,15 +1080,22 @@
       std::string fieldid_str;
       if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS recv field").resume();
-
-      CContext* context = CContext::getCurrent();
-      if (!context->hasServer && !context->client->isAttachedModeEnabled())
-        context->eventLoop();
-//ym        context->checkBuffersAndListen();
-
-      CArray<double, 4>data(data_k8, shape(data_0size, data_1size, data_2size, data_3size), neverDeleteData);
-      CField::get(fieldid_str)->getData(data);
+      cxios_read_data_k84_hdl(CField::get(fieldid_str), data_k8, data_0size, data_1size, data_2size, data_3size) ;
+   }
+   CATCH_DUMP_STACK
+
+   void cxios_read_data_k85_hdl(CField* field, double* data_k8,
+                            int data_0size, int data_1size, int data_2size,
+                            int data_3size, int data_4size)
+   TRY
+   {
+      CTimer::get("XIOS").resume();
+      CTimer::get("XIOS recv field").resume();
+
+      CContext* context = CContext::getCurrent();
+      if (!context->hasServer && !context->client->isAttachedModeEnabled())
+        context->eventLoop();
+
+      CArray<double, 5>data(data_k8, shape(data_0size, data_1size, data_2size, data_3size, data_4size), neverDeleteData);
+      field->getData(data);
 
       CTimer::get("XIOS recv field").suspend();
@@ -912,15 +1111,22 @@
       std::string fieldid_str;
       if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS recv field").resume();
-
-      CContext* context = CContext::getCurrent();
-      if (!context->hasServer && !context->client->isAttachedModeEnabled())
-        context->eventLoop();
-//ym        context->checkBuffersAndListen();
-
-      CArray<double, 5>data(data_k8, shape(data_0size, data_1size, data_2size, data_3size, data_4size), neverDeleteData);
-      CField::get(fieldid_str)->getData(data);
+      cxios_read_data_k85_hdl(CField::get(fieldid_str), data_k8, data_0size, data_1size, data_2size, data_3size, data_4size) ;
+   }
+   CATCH_DUMP_STACK
+
+   void cxios_read_data_k86_hdl(CField* field, double* data_k8,
+                            int data_0size, int data_1size, int data_2size,
+                            int data_3size, int data_4size, int data_5size)
+   TRY
+   {
+      CTimer::get("XIOS").resume();
+      CTimer::get("XIOS recv field").resume();
+
+      CContext* context = CContext::getCurrent();
+      if (!context->hasServer && !context->client->isAttachedModeEnabled())
+        context->eventLoop();
+
+      CArray<double, 6>data(data_k8, shape(data_0size, data_1size, data_2size, data_3size, data_4size, data_5size), neverDeleteData);
+      field->getData(data);
 
       CTimer::get("XIOS recv field").suspend();
@@ -936,22 +1142,9 @@
       std::string fieldid_str;
       if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS recv field").resume();
-
-      CContext* context = CContext::getCurrent();
-      if (!context->hasServer && !context->client->isAttachedModeEnabled())
-        context->eventLoop();
-//ym        context->checkBuffersAndListen();
-
-      CArray<double, 6>data(data_k8, shape(data_0size, data_1size, data_2size, data_3size, data_4size, data_5size), neverDeleteData);
-      CField::get(fieldid_str)->getData(data);
-
-      CTimer::get("XIOS recv field").suspend();
-      CTimer::get("XIOS").suspend();
-   }
-   CATCH_DUMP_STACK
-
-   void cxios_read_data_k87(const char* fieldid, int fieldid_size, double* data_k8,
+      cxios_read_data_k86_hdl(CField::get(fieldid_str), data_k8, data_0size, data_1size, data_2size, data_3size, data_4size, data_5size) ;
+   }
+   CATCH_DUMP_STACK
+
+   void cxios_read_data_k87_hdl(CField* field, double* data_k8,
                             int data_0size, int data_1size, int data_2size,
                             int data_3size, int data_4size, int data_5size,
@@ -959,39 +1152,48 @@
    TRY
    {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS recv field").resume();
-
-      CContext* context = CContext::getCurrent();
-      if (!context->hasServer && !context->client->isAttachedModeEnabled())
-        context->eventLoop();
-//ym        context->checkBuffersAndListen();
+      CTimer::get("XIOS").resume();
+      CTimer::get("XIOS recv field").resume();
+
+      CContext* context = CContext::getCurrent();
+      if (!context->hasServer && !context->client->isAttachedModeEnabled())
+        context->eventLoop();
 
       CArray<double, 7>data(data_k8, shape(data_0size, data_1size, data_2size, data_3size, data_4size, data_5size, data_6size), neverDeleteData);
-      CField::get(fieldid_str)->getData(data);
-
-      CTimer::get("XIOS recv field").suspend();
-      CTimer::get("XIOS").suspend();
-   }
-   CATCH_DUMP_STACK
-
-   void cxios_read_data_k40(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS recv field").resume();
-
-      CContext* context = CContext::getCurrent();
-      if (!context->hasServer && !context->client->isAttachedModeEnabled())
-        context->eventLoop();
-//ym        context->checkBuffersAndListen();
+      field->getData(data);
+
+      CTimer::get("XIOS recv field").suspend();
+      CTimer::get("XIOS").suspend();
+   }
+   CATCH_DUMP_STACK
+
+   void cxios_read_data_k87(const char* fieldid, int fieldid_size, double* data_k8,
+                            int data_0size, int data_1size, int data_2size,
+                            int data_3size, int data_4size, int data_5size,
+                            int data_6size)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_read_data_k87_hdl(CField::get(fieldid_str), data_k8, data_0size, data_1size, data_2size, data_3size, data_4size, data_5size, data_6size) ;
+   }
+   CATCH_DUMP_STACK
+
+
+
+
+
+
+   void cxios_read_data_k40_hdl(CField* field, float* data_k4, int data_Xsize)
+   TRY
+   {
+      CTimer::get("XIOS").resume();
+      CTimer::get("XIOS recv field").resume();
+
+      CContext* context = CContext::getCurrent();
+      if (!context->hasServer && !context->client->isAttachedModeEnabled())
+        context->eventLoop();
 
       CArray<double, 1> data(data_Xsize);
-      CField::get(fieldid_str)->getData(data);
+      field->getData(data);
       CArray<float, 1> data_tmp(data_k4, shape(data_Xsize), neverDeleteData);
       data_tmp = data;
@@ -1002,20 +1204,27 @@
    CATCH_DUMP_STACK
 
-   void cxios_read_data_k41(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS recv field").resume();
-
-      CContext* context = CContext::getCurrent();
-      if (!context->hasServer && !context->client->isAttachedModeEnabled())
-        context->eventLoop();
-//ym        context->checkBuffersAndListen();
+   void cxios_read_data_k40(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_read_data_k40_hdl(CField::get(fieldid_str), data_k4, data_Xsize) ;
+   }
+   CATCH_DUMP_STACK
+
+
+
+   void cxios_read_data_k41_hdl(CField* field, float* data_k4, int data_Xsize)
+   TRY
+   {
+      CTimer::get("XIOS").resume();
+      CTimer::get("XIOS recv field").resume();
+
+      CContext* context = CContext::getCurrent();
+      if (!context->hasServer && !context->client->isAttachedModeEnabled())
+        context->eventLoop();
 
       CArray<double, 1> data(data_Xsize);
-      CField::get(fieldid_str)->getData(data);
+      field->getData(data);
       CArray<float, 1> data_tmp(data_k4, shape(data_Xsize), neverDeleteData);
       data_tmp = data;
@@ -1026,20 +1235,28 @@
    CATCH_DUMP_STACK
 
-   void cxios_read_data_k42(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize, int data_Ysize)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS recv field").resume();
-
-      CContext* context = CContext::getCurrent();
-      if (!context->hasServer && !context->client->isAttachedModeEnabled())
-        context->eventLoop();
-//ym        context->checkBuffersAndListen();
+   void cxios_read_data_k41(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_read_data_k41_hdl(CField::get(fieldid_str), data_k4, data_Xsize) ;
+   }
+   CATCH_DUMP_STACK
+
+
+
+
+   void cxios_read_data_k42_hdl(CField* field, float* data_k4, int data_Xsize, int data_Ysize)
+   TRY
+   {
+      CTimer::get("XIOS").resume();
+      CTimer::get("XIOS recv field").resume();
+
+      CContext* context = CContext::getCurrent();
+      if (!context->hasServer && !context->client->isAttachedModeEnabled())
+        context->eventLoop();
 
       CArray<double, 2> data(data_Xsize, data_Ysize);
-      CField::get(fieldid_str)->getData(data);
+      field->getData(data);
       CArray<float, 2> data_tmp(data_k4, shape(data_Xsize, data_Ysize), neverDeleteData);
       data_tmp = data;
@@ -1050,20 +1267,27 @@
    CATCH_DUMP_STACK
 
-   void cxios_read_data_k43(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize, int data_Ysize, int data_Zsize)
-   TRY
-   {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS recv field").resume();
-
-      CContext* context = CContext::getCurrent();
-      if (!context->hasServer && !context->client->isAttachedModeEnabled())
-        context->eventLoop();
-//ym        context->checkBuffersAndListen();
+   void cxios_read_data_k42(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize, int data_Ysize)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_read_data_k42_hdl(CField::get(fieldid_str), data_k4, data_Xsize, data_Ysize) ;
+   }
+   CATCH_DUMP_STACK
+
+
+
+   void cxios_read_data_k43_hdl(CField* field, float* data_k4, int data_Xsize, int data_Ysize, int data_Zsize)
+   TRY
+   {
+      CTimer::get("XIOS").resume();
+      CTimer::get("XIOS recv field").resume();
+
+      CContext* context = CContext::getCurrent();
+      if (!context->hasServer && !context->client->isAttachedModeEnabled())
+        context->eventLoop();
 
       CArray<double, 3> data(data_Xsize, data_Ysize, data_Zsize);
-      CField::get(fieldid_str)->getData(data);
+      field->getData(data);
       CArray<float, 3> data_tmp(data_k4, shape(data_Xsize, data_Ysize, data_Zsize), neverDeleteData);
       data_tmp = data;
@@ -1074,22 +1298,28 @@
    CATCH_DUMP_STACK
 
-   void cxios_read_data_k44(const char* fieldid, int fieldid_size, float* data_k4,
+   void cxios_read_data_k43(const char* fieldid, int fieldid_size, float* data_k4, int data_Xsize, int data_Ysize, int data_Zsize)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_read_data_k43_hdl(CField::get(fieldid_str), data_k4,data_Xsize, data_Ysize, data_Zsize) ;
+    }
+   CATCH_DUMP_STACK
+
+
+   void cxios_read_data_k44_hdl(CField* field, float* data_k4,
                             int data_0size, int data_1size, int data_2size,
                             int data_3size)
    TRY
    {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS recv field").resume();
-
-      CContext* context = CContext::getCurrent();
-      if (!context->hasServer && !context->client->isAttachedModeEnabled())
-        context->eventLoop();
-//ym        context->checkBuffersAndListen();
+      CTimer::get("XIOS").resume();
+      CTimer::get("XIOS recv field").resume();
+
+      CContext* context = CContext::getCurrent();
+      if (!context->hasServer && !context->client->isAttachedModeEnabled())
+        context->eventLoop();
 
       CArray<double, 4> data(data_0size, data_1size, data_2size, data_3size);
-      CField::get(fieldid_str)->getData(data);
+      field->getData(data);
       CArray<float, 4> data_tmp(data_k4, shape(data_0size, data_1size, data_2size, data_3size), neverDeleteData);
       data_tmp = data;
@@ -1100,22 +1330,31 @@
    CATCH_DUMP_STACK
 
-   void cxios_read_data_k45(const char* fieldid, int fieldid_size, float* data_k4,
+   void cxios_read_data_k44(const char* fieldid, int fieldid_size, float* data_k4,
+                            int data_0size, int data_1size, int data_2size,
+                            int data_3size)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_read_data_k44_hdl(CField::get(fieldid_str), data_k4, data_0size, data_1size, data_2size, data_3size) ;
+    }
+   CATCH_DUMP_STACK
+
+
+
+   void cxios_read_data_k45_hdl(CField* field, float* data_k4,
                             int data_0size, int data_1size, int data_2size,
                             int data_3size, int data_4size)
    TRY
    {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS recv field").resume();
-
-      CContext* context = CContext::getCurrent();
-      if (!context->hasServer && !context->client->isAttachedModeEnabled())
-        context->eventLoop();
-//ym        context->checkBuffersAndListen();
+      CTimer::get("XIOS").resume();
+      CTimer::get("XIOS recv field").resume();
+
+      CContext* context = CContext::getCurrent();
+      if (!context->hasServer && !context->client->isAttachedModeEnabled())
+        context->eventLoop();
 
       CArray<double, 5> data(data_0size, data_1size, data_2size, data_3size, data_4size);
-      CField::get(fieldid_str)->getData(data);
+      field->getData(data);
       CArray<float, 5> data_tmp(data_k4, shape(data_0size, data_1size, data_2size, data_3size, data_4size), neverDeleteData);
       data_tmp = data;
@@ -1126,22 +1365,30 @@
    CATCH_DUMP_STACK
 
-   void cxios_read_data_k46(const char* fieldid, int fieldid_size, float* data_k4,
+   void cxios_read_data_k45(const char* fieldid, int fieldid_size, float* data_k4,
+                            int data_0size, int data_1size, int data_2size,
+                            int data_3size, int data_4size)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_read_data_k45_hdl(CField::get(fieldid_str), data_k4, data_0size, data_1size, data_2size, data_3size, data_4size) ;
+    }
+   CATCH_DUMP_STACK
+
+
+   void cxios_read_data_k46_hdl(CField* field, float* data_k4,
                             int data_0size, int data_1size, int data_2size,
                             int data_3size, int data_4size, int data_5size)
    TRY
    {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS recv field").resume();
-
-      CContext* context = CContext::getCurrent();
-      if (!context->hasServer && !context->client->isAttachedModeEnabled())
-        context->eventLoop();
-//ym        context->checkBuffersAndListen();
+      CTimer::get("XIOS").resume();
+      CTimer::get("XIOS recv field").resume();
+
+      CContext* context = CContext::getCurrent();
+      if (!context->hasServer && !context->client->isAttachedModeEnabled())
+        context->eventLoop();
 
       CArray<double, 6> data(data_0size, data_1size, data_2size, data_3size, data_4size, data_5size);
-      CField::get(fieldid_str)->getData(data);
+      field->getData(data);
       CArray<float, 6> data_tmp(data_k4, shape(data_0size, data_1size, data_2size, data_3size, data_4size, data_5size), neverDeleteData);
       data_tmp = data;
@@ -1152,5 +1399,18 @@
    CATCH_DUMP_STACK
 
-   void cxios_read_data_k47(const char* fieldid, int fieldid_size, float* data_k4,
+   void cxios_read_data_k46(const char* fieldid, int fieldid_size, float* data_k4,
+                            int data_0size, int data_1size, int data_2size,
+                            int data_3size, int data_4size, int data_5size)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_read_data_k46_hdl(CField::get(fieldid_str), data_k4, data_0size, data_1size, data_2size, data_3size, data_4size, data_5size) ;
+    }
+   CATCH_DUMP_STACK
+
+
+
+   void cxios_read_data_k47_hdl(CField* field, float* data_k4,
                             int data_0size, int data_1size, int data_2size,
                             int data_3size, int data_4size, int data_5size,
@@ -1158,17 +1418,13 @@
    TRY
    {
-      std::string fieldid_str;
-      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
-
-      CTimer::get("XIOS").resume();
-      CTimer::get("XIOS recv field").resume();
-
-      CContext* context = CContext::getCurrent();
-      if (!context->hasServer && !context->client->isAttachedModeEnabled())
-        context->eventLoop();
-//ym        context->checkBuffersAndListen();
+      CTimer::get("XIOS").resume();
+      CTimer::get("XIOS recv field").resume();
+
+      CContext* context = CContext::getCurrent();
+      if (!context->hasServer && !context->client->isAttachedModeEnabled())
+        context->eventLoop();
 
       CArray<double, 7> data(data_0size, data_1size, data_2size, data_3size, data_4size, data_5size, data_6size);
-      CField::get(fieldid_str)->getData(data);
+      field->getData(data);
       CArray<float, 7> data_tmp(data_k4, shape(data_0size, data_1size, data_2size, data_3size, data_4size, data_5size, data_6size), neverDeleteData);
       data_tmp = data;
@@ -1178,3 +1434,15 @@
     }
    CATCH_DUMP_STACK
+ 
+   void cxios_read_data_k47(const char* fieldid, int fieldid_size, float* data_k4,
+                            int data_0size, int data_1size, int data_2size,
+                            int data_3size, int data_4size, int data_5size,
+                            int data_6size)
+   TRY
+   {
+      std::string fieldid_str;
+      if (!cstr2string(fieldid, fieldid_size, fieldid_str)) return;
+      cxios_read_data_k47_hdl(CField::get(fieldid_str), data_k4, data_0size, data_1size, data_2size, data_3size, data_4size, data_5size, data_6size) ;
+    }
+   CATCH_DUMP_STACK
 } // extern "C"
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/interface/fortran/context_interface.f90
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/interface/fortran/context_interface.f90	(revision 2115)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/interface/fortran/context_interface.f90	(revision 2121)
@@ -16,4 +16,11 @@
       END SUBROUTINE cxios_context_get_current
 
+      SUBROUTINE cxios_context_get_id(context, idt, idt_size) BIND(C)
+         import C_CHAR, C_INTPTR_T, C_INT
+         INTEGER (kind = C_INTPTR_T) :: context
+         CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: idt
+         INTEGER  (kind = C_INT)     , VALUE        :: idt_size
+     END SUBROUTINE cxios_context_get_id
+
       SUBROUTINE cxios_context_set_current(context, withswap) BIND(C)
          import C_BOOL, C_INT, C_INTPTR_T
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/interface/fortran/icontext.F90
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/interface/fortran/icontext.F90	(revision 2115)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/interface/fortran/icontext.F90	(revision 2121)
@@ -17,4 +17,8 @@
    END INTERFACE xios(set_current_context)
 
+   INTERFACE xios(get_current_context)
+      MODULE PROCEDURE xios(get_current_context_hdl), xios(get_current_context_id)
+   END INTERFACE xios(get_current_context)
+
    CONTAINS ! Fonctions disponibles pour les utilisateurs.
 
@@ -27,13 +31,23 @@
    END SUBROUTINE xios(get_context_handle)
 
-   SUBROUTINE xios(get_current_context)(context)
+   SUBROUTINE xios(get_current_context_hdl)(context)
       IMPLICIT NONE
 
-      TYPE(txios(context)), INTENT(IN) :: context
+      TYPE(txios(context)), INTENT(OUT) :: context
 
       CALL cxios_context_get_current(context%daddr)
 
-   END SUBROUTINE xios(get_current_context)
+   END SUBROUTINE xios(get_current_context_hdl)
 
+   SUBROUTINE xios(get_current_context_id)(idt)
+      IMPLICIT NONE
+      CHARACTER(len = *) , INTENT(OUT) :: idt
+      TYPE(txios(context)) :: context
+
+      CALL cxios_context_get_current(context%daddr)
+      CALL cxios_context_get_id(context%daddr, idt, len(idt))
+
+   END SUBROUTINE xios(get_current_context_id)
+   
    SUBROUTINE xios(set_current_context_hdl)(context, withswap)
       IMPLICIT NONE
